Subject: bug#40344: inconsistent 'guix package --list-generations' for root

From: Leo Famulari <[email-masked]>
Date: Tue, 31 Mar 2020 11:45:48 -0400

On Tue, Mar 31, 2020 at 11:54:36AM +0300, Efraim Flashner wrote:
> When I run 'sudo guix package --list-generations' on a foreign distro
> I get a list of all the profiles for all the users, not just for root.

It's complicated on foreign distros, since they vary in how they
configure sudo, and since Guix is really based on login environments.

I think it's correct that you'd see your own user's generations. Doing
`sudo foo` doesn't totally change your user from Guix's point of view,
just your privilege level. You'd need `sudo --login` to become root.

Try `env`, `sudo env`, `sudo --login env`...

It's definitely not expected to see all the users' generations, though
(I can't reproduce that).

Exactly how it works on the foreign distro will probably vary by distro
and setup, however. `sudo guix ...` doesn't work at all on my Debian; it
fails with "sudo: guix: command not found" and I have to use `sudo
--login`.